#ifndef CMSC202_BST_H
#define CMSC202_BST_H


#include <iostream.h>

template <class T>
class BST;

template <class T>
class BSTNode {
private:
        BSTNode(T v, BSTNode *l, BSTNode *r);

        static int isEmpty(BSTNode<T> *n);
	static int isLeaf(BSTNode<T> *n);

	void insert(T x);
	int find(T x);
	BSTNode<T> * remove(T x);

	T findmin();
	T findmax();
	
	T value;
	BSTNode * left, * right;

	friend class BST<T>;	
};

template <class T>
class BST {
public:
	BST();
	
	void insert(T x); 
	void remove(T x); 
	int find(T x);
	
	int isEmpty(); 

	T value(); 
	BST left(); 
	BST right();

	friend ostream & operator <<(ostream &, BST<T>);

private:
	BST(BSTNode<T> *r); 

	BSTNode<T> * root;
};

	
template <class T>
ostream & operator <<(ostream & os, BST<T> t); 


#endif
