#include <iostream.h>
#include "BST.H"

#include <stdlib.h>
#include <time.h>

void 
main(int argc, char *argv[]) 
{
	BST<int> t;
	int * values, n, value, max;


	//  Some usage checking to make sure the user enters at least 
	//  the right number of arguments.
	if (argc != 3) {
		cerr << "Usage: " << argv[0] 
		     << " <number of nodes> <max value>" << endl;
		return;
	} else {
		n = atoi(argv[1]);
		max = atoi(argv[2]);
	}


	//  Allocate space to store the list of values (this is so we 
	//  know what to find/delete later.
	values = new int [n];


	//  We want to make a BST of random numbers, so we have
	//  to seed the random number generator.  In this case 
	//  we'll use the current time as a seed value.  See
	//  "man 2 time" and "man 3 random" for more details.
	srandom(time(NULL));


	//  Build the tree from a list of random numbers.  Note
	//  that there could be duplicates in this list!
	for (int i=0; i<n; i++) {
		value = random() % max;
		values[i] = value;
		t.insert(value);
	
		cout << "t: " << t << endl;
	}


	cout << endl << "--------------------------------" << endl << endl;

	//  Pick a random value to find
	value = values[random()%n];

	//  Find that value and another value (<0) that's
	//  guaranteed not to be in the list.
	for (i=0; i<2; i++) {
		cout << "Testing find(" << value << "): ";

		if (t.find(value)) 
			cout << "Found it!" << endl;
		else           
			cout << "Didn't find it!" << endl;

		value = -(random()%max);
	}

	cout << endl << "--------------------------------" << endl << endl;

	for (i=0; i< (n/2)%n+1; i++) {
		cout << "Testing remove(" << value << "): ";
		t.remove(value);
		cout << t << endl;
		
		value = values[random()%n];
	}

	cout << endl << "Finished testing!" << endl;
}	
